#!/bin/sh
## File name: java.cgi
## Usage:     java.cgi ClassName args ...
##CGI_DIR=/var/www/html/fcm/tymos/cgi-bin
CGI_DIR=/var/www/cgi-bin

## set environment variables CLASSPATH and
## LD_LIBRARY_PATH also when necessary

cd $CGI_DIR
exec /usr/local/jdk/bin/java -DCONTENT_TYPE=$CONTENT_TYPE\
	  -DCONTENT_LENGTH=$CONTENT_LENGTH\
	  -DREQUEST_METHOD=$REQUEST_METHOD\
	  -DQUERY_STRING=$QUERY_STRING\
	  -DSERVER_NAME=$SERVER_NAME\
	  -DSERVER_PORT=$SERVER_PORT\
	  -DSCRIPT_NAME=$SCRIPT_NAME\
	  -DPATH_INFO=$PATH_INFO\
	$* ## this gives the Java class name and its args
