//  Autor: Tymoschuk, Jorge
import java.io.*;    //  for file I/O
import In;           //  facilidades Garcia

class RAF{			 //  RandomAccessFile 
	private int accesos, puntos;
	private String coments,antcoments="";
	private float  porcent;
	        File       file; 
	        RandomAccessFile iofile;
	public RAF(int ptos, String obs){
		puntos =ptos;		//  Lo que viene del main()
		coments=obs;
	}	
	boolean openRAF(){
		file = new File("EncuestaPPR");
		System.out.println("file creado, ahora el RAF");
    	try
	   		{iofile = new RandomAccessFile(file,"rw");
       			System.out.println("RAF abierto");
       		}catch (IOException e){
				System.out.println("IOException en bloque try");
            	return false;
		     }	
		return true; // O sea, todo bien ...
}

   	void readRAF()throws IOException{
		if(file.length()==0){ // primera vez
			System.out.println("Primer acceso, RAF empty...");
			accesos=1;
		}	
		else{
			System.out.println("Leyendo RAF ...");
			try{
      			accesos=iofile.readInt()+1; 	//  Mas un acceso,
				puntos+=iofile.readInt();   	//  actualizamos puntaje
				antcoments=iofile.readUTF();  //  y registramos comentario.
			} catch (IOException e){
				System.out.println("Error de lectura ...");
				System.exit(1);
			  }
		}
    }

	public String toString(){
		StringBuffer buf = new StringBuffer();
		float porcent= (float)puntos/accesos;
		buf.append(" Despues de su muy apreciada evaluacion,\n");
		buf.append("registramos "+accesos+" accesos, y el porcent-\n");
		buf.append("je de valorativo de su actuacion se si-\n");
		buf.append("tua en "+porcent+"\n");
		buf.append("La opinion del encuestado anterior fue:\n");
		buf.append(antcoments+"\n");
		buf.setLength(buf.length()-1);
		return new String(buf);
	} 	

   	void grabRAF()throws IOException{
		try{iofile.seek(0);// reposicionar file 
       		iofile.writeInt(accesos);
			iofile.writeInt(puntos);
			iofile.writeUTF(coments);
			System.out.println("RAF actualizado .\n");
			} catch (IOException e){
				System.out.println("Error de grabacion .");
				System.exit(1);
		}

    }

}

public class TestRAF{
    public static void main (String args[])
    {   
    	int puntos;
		String observ;
    	System.out.println("");
    	System.out.println("Gran Encuesta Catedra Paradigmas, gran ..");
    	System.out.println("=========================================");
    	System.out.println("");
    	System.out.println("Si consideramos el desempeo de esta catedra");
    	System.out.print("en cuantos puntos, (0..100), la valua Ud.?");
    	puntos = In.readInt();
		System.out.print("En una linea, que nos puede decir de ella ?\n");
		observ = In.readLine();
		System.out.print("\nProcesando ...");
		System.out.print("\n==============\n");
		RAF raf= new RAF(puntos,observ);
		try{
			if(raf.openRAF()){
				raf.readRAF();
				raf.grabRAF();
				System.out.println(raf);
				System.out.println("");
			}
			else
			{  	System.out.println("No pude abrir RAF");
				System.exit(1);
			}
		} catch (IOException e){
				System.out.println("Error de grabacion .");
				System.exit(1);
			}
	}	
}
