//  Autor: Tymoschuk, Jorge
import java.io.*;
import java.net.*;
import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextArea;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.security.*;
public class Reverse extends JApplet{ 
	String textTip, textDec;
  	JLabel etiqueta;
  	JTextArea frase;
  	JButton procesar;
  	int x=10,y=120; 	// Coordenadas de la etiqueta para report(...)
  	int w=380,h=20;		// Tamao de la idem

  	public void init() {
    	try { // usando camiseta Windows
    		javax.swing.UIManager.setLookAndFeel(
    		"com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    	} catch (Exception  e) {;}

    	// elimina la distribucin automtica de componentes
    	this.getContentPane().setLayout(null);

    	// creacin y configuracin de la etiqueta
    	etiqueta = new JLabel(" Frase a revertir, por favor ...");
    	etiqueta.setSize(380, 20);
    	etiqueta.setLocation(10, 10);
    	this.getContentPane().add(etiqueta);

		// creacin y configuracin del area de texto
		frase = new JTextArea(2,40);
		frase.setSize(270, 50);
		frase.setLocation(10, 30);
		frase.setLineWrap(true);
		this.getContentPane().add(frase);

		// creacin y configuracin del boton procesar 
    	procesar = new JButton("Procesar inversion");
    	procesar.setSize(150, 27);
    	procesar.setLocation(130,110);
    	this.getContentPane().add(procesar);
    	procesar.addMouseListener(new Eventos(this));
  	}	// init()

  	void report(String msge){
  		etiqueta = new JLabel(msge);
    	etiqueta.setSize(w,h);
  		etiqueta.setLocation(x,y+=10);
  		this.getContentPane().add(etiqueta);
		repaint();
  	}
	
	void leerFrase(){   
		textTip=frase.getText();
		this.report(textTip);
	}

	void codiFrase(){   
		textDec=URLEncoder.encode(textTip);
		this.report(textDec);
	}
	
	void procFrase() { 
		this.report("En tramite de conexion ...");
		try {
			URL urlObj=new URL("http://java.sun.com/cgi-bin/backwards");
			URLConnection urlObjConnect = urlObj.openConnection();
			urlObjConnect.setDoOutput(true);
			this.report("Conexion establecida ...");
			PrintWriter out = new PrintWriter(urlObjConnect.getOutputStream());
			this.report("Objeto out instanciado...");
			out.println("string=" + textDec);
			//  Aqui enviamos stringToReverse a cgi-bin/backwards   
			this.report("Mensaje enviado, paciencia ...");
			out.close(); // Nada mas diremos a backwards 
			BufferedReader in = new BufferedReader(
				new InputStreamReader(
				urlObjConnect.getInputStream()));
			/*	Definimos un objeto in, de tipo BufferedReader cuya mision es 
			posibilitar la lectura de la 	salida 	textual generada por 
			cgi-bin/backwards  */
			String inputLine;
			this.report("Preparandonos a la recepcion ...");
			while ((inputLine = in.readLine()) != null)
				this.report(inputLine);
			this.report("==========================");
			in.close();
		} catch (MalformedURLException exce){
			this.report("Lamento, MalformedURLException");}
		  catch (IOException exce){
			this.report("URLConnection, IOException");
			this.report("PrintWriter out, IOException");}	
		  catch (AccessControlException exce){
			this.report("Lamento, AccessControlException exce");
			this.report("Tema de socket, controlado  en java.sun.com ...");}	
	}
}


class Eventos extends MouseAdapter{
	private Reverse objRev;
	Eventos(Reverse objRev){
		this.objRev=objRev;
	}

    public void mouseClicked(MouseEvent e) {
  		objRev.report("- Proc. sol. en curso ...");
		objRev.leerFrase(); 
		objRev.codiFrase(); 
		try {
			objRev.procFrase();
		} catch (Exception  exce) {
			objRev.report("Lamento, some Exception ...");}
  	}	
}
