//	Cliente del Gateway Prac002

//  Autor: Tymoschuk, Jorge

import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Graphics;
import java.security.*;
public class Clie002 extends JFrame{ 
	String parametros;
  	JLabel etiqueta;
  	JTextField desdeReg;
  	JButton procesar, salir;
	int x=10,y=30; 		// Coordenadas de la etiqueta para report(...)
	int w=380,h=20;		// Tamao de la idem
	Graphics g;

  	public void iniciar() {
    	try { // usando camiseta Windows
    		javax.swing.UIManager.setLookAndFeel(
    		"com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    	} catch (Exception  e) {;}

    	// elimina la distribucin automtica de componentes
    	this.getContentPane().setLayout(null);
		this.setSize(800,520);
    	// creacin y configuracin de etiquetas y campos de texto 
    	etiqueta = new JLabel("Primer Practico en RED,  procesar desde registro");
    	etiqueta.setSize(400, 20);
    	etiqueta.setLocation(20, 10);
    	this.getContentPane().add(etiqueta);
    	
		desdeReg = new JTextField(5);
		desdeReg.setSize(45, 20);
		desdeReg.setLocation(300, 10);
		this.getContentPane().add(desdeReg);

		ActionListener escuchaAccion = new Eventos(this); 

		// creacin y configuracin del boton Procesar 
    	procesar = new JButton("Procesar");
    	procesar.setSize(90, 27);
    	procesar.setLocation(600,10);
    	this.getContentPane().add(procesar);
    	procesar.addActionListener(escuchaAccion);

  		// creacin y configuracin del boton salir 
  		salir = new JButton("Salir");
  		salir.setSize(60, 27);
  		salir.setLocation(700,10);
  		this.getContentPane().add(salir);
  		salir.addActionListener(escuchaAccion);
  		show();
  	}	// iniciar()

	void leerTodo(){
		parametros = " "+"tymos"+       //  directorio
					 " "+"regPra01"+	//  archivo RAF
					 " "+ desdeReg.getText();  //  a partir de
					 							
		parametros = URLEncoder.encode(parametros);
		this.report(parametros);
	}
	
	void procFrase() { 
		this.report("En tramite de conexion ...");
		try {
			URL urlObj=new URL("http://labsys.frc.utn.edu.ar/cgi-bin/java.cgi?Prac002"+parametros);
			URLConnection urlObjConnect = urlObj.openConnection();
			urlObjConnect.setDoOutput(true);
			this.report("Conexion establecida ...");
			PrintWriter out = new PrintWriter(urlObjConnect.getOutputStream());
			this.report("Objeto out instanciado...");
			//  Aqui enviamos stringToReverse a cgi-bin/java.cgi?Prac002   
			this.report("Mensaje enviado, paciencia ...");
			out.close(); // Nada mas diremos a backwards 
			BufferedReader in = new BufferedReader(
				new InputStreamReader(
				urlObjConnect.getInputStream()));
			/*	Definimos un objeto in, de tipo BufferedReader cuya mision es 
			posibilitar la lectura de la 	salida 	textual generada por 
			cgi-bin/backwards  */
			String inputLine;
			this.report("Preparandonos a la recepcion ...");
			while ((inputLine = in.readLine()) != null)
				this.report(inputLine);
			this.report("==========================");
			in.close();
		} catch (MalformedURLException exce){
			this.report("Lamento, MalformedURLException");}
		  catch (IOException exce){
			this.report("URLConnection, IOException");
			this.report("PrintWriter out, IOException");}	
		  catch (AccessControlException exce){
			this.report("Lamento, AccessControlException exce");
			this.report("Tema de socket, controlado  en java.sun.com ...");}	
	}

	void report(String msge){
		etiqueta = new JLabel(msge);
		etiqueta.setSize(w,h);
		etiqueta.setLocation(x,y+=10);
		this.getContentPane().add(etiqueta);
		repaint();
	}

	class Eventos implements ActionListener{
		Clie002 clieServ;
		Eventos(Clie002 clieServ){
		this.clieServ=clieServ;}
		public void actionPerformed(ActionEvent e){
			if(e.getSource() == procesar){
				clieServ.leerTodo();
			try {
					clieServ.procFrase();
				} catch (Exception  exce) {
					clieServ.report("Lamento, some Exception ...");} 
			}	// if (e.getSource()
			else System.exit(1);
		} 	// actionPerformed
	}		// class Eventos
}			// class Clie001


class PrueClie002{ 
    public static void main(String args[]) {
		Clie002 clieServ=new Clie002();
		clieServ.iniciar();		
 	}	// main()
}
	
