import java.io.*;
import java.net.*;

/**
   Este programa realiza una coneccion Socket a un reloj atomico en 
   Boulder, Colorado, y muestra la hora que el servidor envia 
*/
public class SocketTest
{  
   public static void main(String[] args)
   {  
      try
      {  
         Socket s = new Socket("time-A.timefreq.bldrdoc.gov",13);
         // Instanciamos un objeto Socket s; 
         // parametros: direccion remota y puerto 

         BufferedReader in = new BufferedReader
            (new InputStreamReader(s.getInputStream()));
            //  Instanciamos un objeto in, clase BufferedReader 
            //  Usando el objeto Socket s activamos getInputStream() 
            //  de la clase InputStreamReader.
            //  El retorno de la expresion anterior es parametro del
            //  constructor de  BufferedReader, quien instancia in 
         
         boolean more = true;
         while (more)   //  Ciclo de lectura del flujo in
         {  
            String line = in.readLine();
            if (line == null) 
               more = false;
            else
               System.out.println(line);
         }

      }
      catch (IOException e)
      {  
         e.printStackTrace();
      }
   }
}
