//  Autor: Tymoschuk, Jorge
import java.io.*;
import java.net.*;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JTextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Graphics;
import java.security.*;
public class Reverse extends JFrame{ 
	String textTip, textDec;
  	JLabel etiqueta;
  	JTextArea frase;
  	JButton invertir, salir;
	Graphics g;
  	int x=10,y=130; 	// Coordenadas de la etiqueta para report(...)
  	int w=380,h=20;		// Tamao de la idem

  	public void iniciar() {
    	try { // usando camiseta Windows
    		javax.swing.UIManager.setLookAndFeel(
    		"com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    	} catch (Exception  e) {;}

    	// elimina la distribucin automtica de componentes
    	this.getContentPane().setLayout(null);
		this.setSize(420,520);
    	// creacin y configuracin de la etiqueta
    	etiqueta = new JLabel(" Frase a revertir, por favor ...");
    	etiqueta.setSize(380, 20);
    	etiqueta.setLocation(10, 10);
    	this.getContentPane().add(etiqueta);

		// creacin y configuracin del area de texto
		frase = new JTextArea(2,40);
		frase.setSize(270, 50);
		frase.setLocation(10, 30);
		frase.setLineWrap(true);
		this.getContentPane().add(frase);

		ActionListener escuchaAccion = new Eventos(this); 

		// creacin y configuracin del boton invertir 
    	invertir = new JButton("Invertir");
    	invertir.setSize(80, 27);
    	invertir.setLocation(10,90);
    	this.getContentPane().add(invertir);
    	invertir.addActionListener(escuchaAccion);

  		// creacin y configuracin del boton salir 
  		salir = new JButton("Salir");
  		salir.setSize(80, 27);
  		salir.setLocation(200,90);
  		this.getContentPane().add(salir);
  		salir.addActionListener(escuchaAccion);
  		show();
  	}	// iniciar()

	void leerFrase(){   
		textTip=frase.getText();
		this.report(textTip);
	}

	void codiFrase(){   
		textDec=URLEncoder.encode(textTip);
		this.report(textDec);
	}
	
	void procFrase() { 
		this.report("En tramite de conexion ...");
		try {
			URL urlObj=new URL("http://java.sun.com/cgi-bin/backwards");
			URLConnection urlObjConnect = urlObj.openConnection();
			urlObjConnect.setDoOutput(true);
			this.report("Conexion establecida ...");
			PrintWriter out = new PrintWriter(urlObjConnect.getOutputStream());
			this.report("Objeto out instanciado...");
			out.println("string=" + textDec);
			//  Aqui enviamos stringToReverse a cgi-bin/backwards   
			this.report("Mensaje enviado, paciencia ...");
			out.close(); // Nada mas diremos a backwards 
			BufferedReader in = new BufferedReader(
				new InputStreamReader(
				urlObjConnect.getInputStream()));
			/*	Definimos un objeto in, de tipo BufferedReader cuya mision es 
			posibilitar la lectura de la 	salida 	textual generada por 
			cgi-bin/backwards  */
			String inputLine;
			this.report("Preparandonos a la recepcion ...");
			while ((inputLine = in.readLine()) != null)
				this.report(inputLine);
			this.report("==========================");
			in.close();
		} catch (MalformedURLException exce){
			this.report("Lamento, MalformedURLException");}
		  catch (IOException exce){
			this.report("URLConnection, IOException");
			this.report("PrintWriter out, IOException");}	
		  catch (AccessControlException exce){
			this.report("Lamento, AccessControlException exce");
			this.report("Tema de socket, controlado  en java.sun.com ...");}	
	}

	void report(String msge){
		etiqueta = new JLabel(msge);
		etiqueta.setSize(w,h);
		etiqueta.setLocation(x,y+=20);
		this.getContentPane().add(etiqueta);
		repaint();
	}

	class Eventos implements ActionListener{
		Reverse objRev;
		Eventos(Reverse objRev){
			this.objRev=objRev;}
		public void actionPerformed(ActionEvent e){
			if(e.getSource() == invertir){
				objRev.report("Proc. solicitado en curso ...");
				objRev.leerFrase(); 
				objRev.codiFrase(); 
				try {
					objRev.procFrase();
				} catch (Exception  exce) {
					objRev.report("Lamento, some Exception ...");}
			}
			else System.exit(1);
		} // actionPerformed
	}	// class Eventos
}	// class Reverse

class prueRev{ 
    public static void main(String args[]) {
		Reverse objRev=new Reverse();
		objRev.iniciar();		
 	}	// main()
}