//	Cliente del Gateway Prac001

//  Autor: Tymoschuk, Jorge

import java.io.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Graphics;
import java.security.*;
public class Clie001 extends JFrame{
    boolean trace;
    String parametros;
    String textTip, textDec;
    JLabel etiqueta;
    JTextField curso, legajo, nombres;  
    JTextArea frase;
    JButton procesar, salir;
    int x, y, w, h;
    public Clie001(boolean trazar){
        x=10; y=240; 	// Coordenadas de la etiqueta para report
        w=380; h=20;	// Tamao de la idem
        trace = trazar;
        Graphics g;
    }
    
    public void iniciar() {
    	try { // usando camiseta Windows
    	    javax.swing.UIManager.setLookAndFeel(
    	    "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    	} catch (Exception  e) {;}

    	// elimina la distribucin automtica de componentes
    	this.getContentPane().setLayout(null);
	this.setSize(420,520);
    	// creacin y configuracin de etiquetas y campos de texto 
    	etiqueta = new JLabel("Practico de Entorno de Red");
    	etiqueta.setSize(300, 20);
    	etiqueta.setLocation(100, 10);
    	this.getContentPane().add(etiqueta);
    	
    	etiqueta = new JLabel("Curso");
    	etiqueta.setSize(50, 20);
    	etiqueta.setLocation(100, 50);
    	this.getContentPane().add(etiqueta);
    	
    	curso = new JTextField(3);
    	curso.setSize(30, 20);
    	curso.setLocation(150, 50);
    	this.getContentPane().add(curso);

    	etiqueta = new JLabel("Legajo");
    	etiqueta.setSize(60, 20);
    	etiqueta.setLocation(220, 50);
    	this.getContentPane().add(etiqueta);
		
	legajo = new JTextField(5);
	legajo.setSize(45, 20);
	legajo.setLocation(270, 50);
	this.getContentPane().add(legajo);

	etiqueta = new JLabel("Apellido, Nombres");
	etiqueta.setSize(120, 20);
	etiqueta.setLocation(50, 80);
	this.getContentPane().add(etiqueta);

	nombres = new JTextField(20);
	nombres.setSize(270, 20);
	nombres.setLocation(50,100);
	this.getContentPane().add(nombres);

	etiqueta = new JLabel("Algo que quiero decir");
	etiqueta.setSize(120, 20);
	etiqueta.setLocation(50, 130);
	this.getContentPane().add(etiqueta);

	frase = new JTextArea(3,40);
	frase.setSize(270, 50);
	frase.setLocation(50, 150);
	frase.setLineWrap(true);
	this.getContentPane().add(frase);

	ActionListener escuchaAccion = new Eventos(); 

	// creacin y configuracin del boton Procesar 
    	procesar = new JButton("Procesar");
    	procesar.setSize(90, 27);
    	procesar.setLocation(50,220);
    	this.getContentPane().add(procesar);
    	procesar.addActionListener(escuchaAccion);

  	// creacin y configuracin del boton salir 
  	salir = new JButton("Salir");
  	salir.setSize(60, 27);
  	salir.setLocation(260,220);
  	this.getContentPane().add(salir);
  	salir.addActionListener(escuchaAccion);
  	show();
    }	// iniciar()

    void leerTodo(){
        parametros = " "+"tymos"+
	             " "+"regPra01"+
		     " "+ curso.getText()+
		     " "+ legajo.getText()+
		     " "+ nombres.getText();
							
	parametros = URLEncoder.encode(parametros);
	if (trace) report(parametros);
	textTip = frase.getText();
	textDec = URLEncoder.encode(textTip);
	if (trace) report(textDec);
    }
	
    void procFrase(){ 
	if (trace) report("En tramite de conexion ...");
	    try {
		URL urlObj=new URL("http://labsys.frc.utn.edu.ar/cgi-bin/java.cgi?Prac001"+parametros);
		URLConnection urlObjConnect = urlObj.openConnection();
		urlObjConnect.setDoOutput(true);
		if (trace) report("Conexion establecida ...");
		PrintWriter out = new PrintWriter(urlObjConnect.getOutputStream());
		if (trace) report("Objeto out instanciado...");
		out.println("string=" + textDec);
		if (trace) report("Mensaje enviado, paciencia por favor ...");
		out.close(); // Nada mas diremos a backwards 
		BufferedReader in = new BufferedReader(
		new InputStreamReader(
				urlObjConnect.getInputStream()));
		/*	Definimos un objeto in, de tipo BufferedReader cuya mision es 
			posibilitar la lectura de la 	salida 	textual generada por 
			cgi-bin/backwards                                           */
		String inputLine;
		if (trace) report("Preparandonos a la recepcion ...");
		while ((inputLine = in.readLine()) != null)
	                report(inputLine);
		if (trace) report("==========================");
		in.close();
	}catch (MalformedURLException exce){
	    report("Lamento, MalformedURLException");
	}catch (IOException exce){
    	    report("URLConnection, IOException");
	    report("PrintWriter out, IOException");	
	}catch (AccessControlException exce){
	    report("Lamento, AccessControlException");
	    report("Tema de socket, controlado  en java.sun.com ...");
        }	
    }   //  void procFrase()

    void report(String msge){
        etiqueta = new JLabel(msge);
        etiqueta.setSize(w,h);
        etiqueta.setLocation(x,y+=10);
        this.getContentPane().add(etiqueta);
        repaint();
    }
    class Eventos implements ActionListener{
        public void actionPerformed(ActionEvent e){
	    if(e.getSource() == procesar){
		leerTodo();
		try{
		    procFrase();
		}catch(Exception exce){report("Lamento, some Exception ...");} 
	    }	// if (e.getSource()
	    else System.exit(1);
	} 	// actionPerformed
    }		// class Eventos
    public static void main(String args[]) {
		Clie001 clieServ=new Clie001(true);
		clieServ.iniciar();		
    }	// main()
}			// class Clie001
